#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "bmp.h"

#define NUMBER_OF_COLORS 256

typedef struct {
	BMPHEADER *bh;
	unsigned char *pixelArray;
	unsigned long pixelArraySize;
} MyImage;

MyImage * copyMyImage (const MyImage * img) {
	unsigned int i;
	MyImage * newImg = NULL;
	BMPHEADER *bh1 = (BMPHEADER *)malloc(sizeof(BMPHEADER));	
	// fail...
	initBmpStruct(bh1, img->bh->info->width, img->bh->info->height);
	newImg = (MyImage *)malloc(sizeof(MyImage));
	// fail...
	newImg->bh = bh1;
	newImg->pixelArraySize = bh1->info->width * bh1->info->height;
	newImg->pixelArray = (unsigned char *) malloc(img->pixelArraySize * sizeof(unsigned char));
	// fail...
	for (i = 0; i < img->pixelArraySize; ++i)		
		newImg->pixelArray[i] = img->pixelArray[i];	
	return newImg;
}

// w,h - output
void getImgDimensions(MyImage * img, int * w, int * h) {
	*w = img->bh->info->width;
	*h = img->bh->info->height;
}

// free header and pixels data
void freeImgMemory(MyImage * img) {
	if (img != NULL) {
		freeBmpMem(img->bh);
		free(img->bh);
		free(img->pixelArray);
		free(img);
	}
}

int getPixel(MyImage * img, int row, int col) {
	return img->pixelArray[img->bh->info->width * row + col];
}

void setPixel(MyImage * img, int row, int col, unsigned char val) {
	img->pixelArray[img->bh->info->width * row + col] = val;
}

MyImage * brightenRectangle(MyImage * img, int row0, int row1, int col0, int col1, int val) {
	int i, j, gl;
	MyImage * newImg = copyMyImage(img);
	for (i=row0;i<=row1;++i) {
		for(j=col0;j<=col1;++j) {
			gl = getPixel(img,i,j);
			setPixel(newImg,i,j,gl+val > 255 ? 255 : gl+val);
		}
	}
	return newImg;
}

int main() {
	unsigned char *bytes;
	BMPHEADER bh;
	MyImage img;
	MyImage * brightImg;

	// Load the image and update the image structure
	loadImage("W:\\C\\MoedA\\image.bmp", &bytes, &bh, &img.pixelArraySize);
	img.bh = &bh;
	img.pixelArray = bytes;

	brightImg = brightenRectangle(&img, 100, 200, 100, 200, 50);
	// fail

	writeImageToFile("W:\\C\\MoedA\\bright.bmp",brightImg->pixelArray,brightImg->bh);

	freeImgMemory(brightImg);

	freeBmpMem(&bh);
	free(bytes);
	
	return 0;
}