#include <stdio.h>
#include <string.h>
# define SIZE 100

typedef struct std{
	char name[SIZE];
	double avgGrade;
	int credits;
	struct std * next;
} Student; 

typedef struct {	
	Student * head;
} List; 

Student * betterStudent (Student * s1, Student * s2) {
	return (s2->avgGrade > s1->avgGrade || 
		(s2->avgGrade == s1->avgGrade) && (s2->credits > s1->credits)) ? s2 : s1;	
}

Student * bestStudent(Student * students) {			
	if (students == NULL)
		return NULL;
	if (students->next == NULL)
		return students;
	return betterStudent(students,bestStudent(students->next));	
}

Student * prevStudent(Student * students, Student * current) {	
	if(students == current)
		return NULL;
	while (students != NULL && students->next != current)
		students = students->next;
	return students;
}

// assumes s and s->next are not NULL
void swapWithNext(List * students, Student * s) {
	Student * prev = prevStudent(students->head, s), * tmp;
	if (prev == NULL) {
		students->head = s->next;
		tmp = s->next->next;
		s->next->next = s;
		s->next = tmp;		
	}
	else {
		prev->next = s->next;
		s->next = s->next->next;
		prev->next->next = s;
	}
}

void bubbleSortStudents(List * students) {
	Student * itr = students->head, * last = NULL;	
	while (itr != last) {
		while (itr->next != last) {
			if (betterStudent(itr,itr->next) == itr)
				swapWithNext(students,itr);
			else
				itr = itr->next;
		}		
		last = itr;
		itr = students->head;		
	}
}


void printList(List * l) {
	Student * itr = l->head;
	printf("--------\n");
	while (itr != NULL) {
		printf("%g, %d\n",itr->avgGrade,itr->credits);
		itr = itr->next;
	}
}

void initStudent(Student * s, char * name, double grade, int credit) {
	strcpy(s->name,name);
	s->avgGrade = grade;
	s->credits = credit;
	s->next = NULL;
}

int main () {
	Student s1,s2,s3,s4,s5,s6;

	List list;
	initStudent(&s1,"A",90,10);
	initStudent(&s2,"B",70,14);
	initStudent(&s3,"C",100,13);
	initStudent(&s4,"D",65,10);
	initStudent(&s5,"E",80,15);
	initStudent(&s6,"F",90,20);	

	list.head = &s1;
	s1.next = &s2;
	s2.next = &s3;
	s3.next = &s4;
	s4.next = &s5;
	s5.next = &s6;

	printf("Starting\n");
	
	printList(&list);
	
	bubbleSortStudents(&list);	

	printList(&list);

	return 0;
}

